; EPILOGUE.ASM
; Run the epilogue end screen

run_epilogue:

	; SWITCH OFF SCREEN

	xor a
	ld b,vdp_reg_mode_2
	call vid_set_vdp_reg

	call vid_clear_vram

	; LOAD THE FONT DATA
	call load_beeb_font

	xor a
	ld (epilogue_line),a
	ld (cur_scroll_index),a


	; SWITCH THE DISPLAY BACK ON:

	ld a,vdp_mode_enable|vdp_mode_double
	ld b,vdp_reg_mode_2
	call vid_set_vdp_reg

	; SET UP THE PSG FOR THE TYPEWRITER NOISE

	ld a,%11100100
	out (psg_port),a


	; Fade in the text:

	xor a


fade_in_ep:
	push af


	ld h,a
	add a,a
	add a,a
	add a,a
	add a,a
	or h

	ld l,a

	ld b,8
	call delay_for_x_frames

	xor a
	call vid_goto_palette

	ld a,l
	out (vdp_data),a
	ld a,h
	out (vdp_data),a

	xor a
	out (vdp_data),a
	out (vdp_data),a

	pop af
	inc a
	cp 16
	jr nz,fade_in_ep

	ld hl,vram_names+12+6*32
	ld (epilogue_name),hl

	ld hl,text_epilogue
	ld (epilogue_txt),hl

write_ep_line:

	call vid_wait_vblank

	call update_ep_scroll

	ld hl,(epilogue_name)
	ld d,h
	ld e,l
	call vid_goto_address

	ld hl,(epilogue_txt)
	ld a,(hl)

	cp $FF
	jp z,finished_all_text

-:	or a
	jr z,+
	push af
	xor a
	out (vdp_data),a
	out (vdp_data),a
	inc de
	inc de
	pop af
	dec a
	jr -
+:

-:	inc hl
	ld a,(hl)
	or a
	jr z,+

	sub $20
	out (vdp_data),a
	xor a
	out (vdp_data),a

	inc de
	inc de

	in a,(start)
	and start_button
	jr z,finished_all_text

	; Switch the PSG tone ON
	ld a,%11110000
	out (psg_port),a

	; RANDOM DELAY

	ld b,18
	call random
	add a,3
	ld b,a

--:	push bc
	call vid_wait_vblank

	; Switch the PSG tone OFF
	ld a,%11111111
	out (psg_port),a



	ld a,(epilogue_line)
	add a,a
	add a,a
	add a,a
	ld b,a
	ld a,(cur_scroll_index)
	add a,144-8
	cp b
	jr nc,no_need_scroll_down


	pop af
	push af
	and %0000001
	jr nz,no_need_scroll_down

	ld a,(cur_scroll_index)
	inc a
	ld (cur_scroll_index),a

	push hl

	call update_ep_scroll

	push de
	pop hl

	call vid_goto_address
	pop hl

no_need_scroll_down:


	pop bc
	djnz --



	jr -

+:

	inc hl
	ld (epilogue_txt),hl

	ld hl,(epilogue_name)
	ld de,64
	add hl,de
	ld (epilogue_name),hl
	ld de,vram_names+64*28+12
	call cp_hl_de
	jr nz,+
	ld hl,vram_names+12
	ld (epilogue_name),hl
+:
	

	ld a,(epilogue_line)
	inc a
	ld (epilogue_line),a

	jp write_ep_line


finished_all_text:

	call wait_start

	; Fade out the text:

	ld a,15

fade_out_ep:
	push af


	ld h,a
	add a,a
	add a,a
	add a,a
	add a,a
	or h

	ld l,a

	ld b,8
	call delay_for_x_frames

	xor a
	call vid_goto_palette

	ld a,l
	out (vdp_data),a

	ld a,h
	out (vdp_data),a

	pop af
	dec a
	cp $FF
	jr nz,fade_out_ep

	ret


update_ep_scroll:
	ld a,(cur_scroll_index)
	ld b,vdp_reg_scroll_y
	call vid_set_vdp_reg
	ret