; LEVELS.INC
; General data for Fire Track

;==============================================================
; TILE INFO
;==============================================================

; Which tiles can be destroyed?
destroyable_tiles:
.db  18, 19, 22, 23, 24, 25, 28, 29, 33, 35, 36, 37, 40, 41, 52, 56, 03, 58, 62, 63, 66, 67, 68, 69, 72, 73, 70, 71, 74, 75, 76, 77, 80, 81
destroyable_tiles_end:

; How many points do we get? (all divided by 2)
destroyed_score:
.db 240,240,240,240,160,160,160,160, 80,140,160,160,160,160, 40, 40, 00, 40,160,160,160,160,240,240,240,240,240,240,240,240,240,240,240,240

; When destroyed, which tiles do we replace them with?
destroyed_tiles:
.db 26,27,30,31,26,27,30,31,44,44,26,27,30,31,44,44,44,44,26,27,30,31,26,27,30,31,26,27,30,31,26,27,30,31


wide_tiles:
.db 18,22,24,28,36,40,33,62,66,68,72,70,74,76,80
wide_tiles_end:


;==============================================================
; LEVEL INFO
;==============================================================


level_index:

; The level index follows this pattern:
; BYTE Map number | 0 [face ending], 128 [platform ending]		+0
; BYTE Palette number | Sprite palette number * 128			+1
; BYTE Attack pattern index | Swap table * 16				+2
; BYTE Attack mode (0=Sequence, 128=Random) | Max number of mines	+3
; BYTE [If attack mode=1, delay between attacks]			+4
; BYTE Speed of enemies | Speed of land * 16
; WORD [If attack mode=0, base location of attack table]		+7+6

; BASEWORLD "CYGNI" 1-3
.db 1|000, 00|00, 0|000, 000|0,$10, 1|16	; 0
.dw attack_level_1
.db 1|000, 01|16, 0|000, 000|0,$10, 1|16	; 1
.dw attack_level_2
.db 2|128, 02|16, 0|000, 000|1,$10, 1|16	; 2
.dw attack_level_3

; DUSTWORLD "DELAN" 4-6

.db 3|000, 03|16, 0|016, 000|1,$10, 2|16	; 3
.dw attack_level_4
.db 3|000, 04|16, 0|016, 000|1,$10, 2|16	; 4
.dw attack_level_3
.db 4|128, 05|16, 0|000, 000|6,$FF, 2|16	; 5
.dw attack_level_3

; ICEWORLD "SHAIL" 7-8

.db 5|000, 02|00, 0|032, 000|0,$01, 1|00	; 6
.dw attack_no_enemies
.db 2|128, 06|16, 0|048, 128|0,$FF, 1|16	; 7
.dw 0

; MALLWORLD "TESLA" 9-11

.db 6|000, 07|00, 0|032, 128|0,$FF, 1|16	; 8
.dw 0
.db 6|000, 08|00, 0|032, 128|0,$FF, 1|16	; 9
.dw 0
.db 4|128, 01|16, 0|048, 128|0,$FF, 1|16	;10
.dw 0

; BASEWORLD "HANAH" 12-14

.db 1|000, 09|00, 0|048, 128|0,$FF, 1|16	;11
.dw 0
.db 2|128, 06|16, 0|048, 128|0,$FF, 1|16	;12
.dw 0

; DUSTWORLD "ABELI" 14-16

.db 3|000, 10|16, 0|064, 128|0,$FF, 1|16	;13
.dw 0
.db 3|000, 01|16, 0|064, 128|0,$FF, 1|16	;14
.dw 0
.db 4|128, 01|16, 0|080, 128|0,$FF, 1|16	;15
.dw 0

; ICEWORLD "GALYE" 17-19

.db 5|000, 11|00, 0|016, 128|0,$FF, 1|16	;16
.dw 0
.db 5|000, 11|00, 0|016, 128|0,$FF, 1|16	;17
.dw 0
.db 2|128, 08|16, 0|096, 128|0,$FF, 1|16	;18
.dw 0

; MALLWORLD "ENOLA" 20-22

.db 6|000, 12|00, 0|112, 128|0,$FF, 1|16	;19
.dw 0
.db 6|000, 06|00, 0|112, 128|0,$FF, 1|16	;20
.dw 0
.db 4|128, 13|16, 0|128, 128|0,$FF, 1|16	;21
.dw 0


;==============================================================
; MAP POINTERS:
;==============================================================

map_pointers:
.dw map_level_1,map_level_1_end
.dw map_level_2,map_level_2_end
.dw map_level_3,map_level_3_end
.dw map_level_4,map_level_4_end
.dw map_level_5,map_level_5_end
.dw map_level_6,map_level_6_end

;==============================================================
; SWAP TABLES
;==============================================================

swap_pointers:
; Apologies for the pretty ropey names _
.dw swap_star_ring_doughnut_x_grille_square		   ; 16
.dw swap_square_grille					   ; 32
.dw swap_square_grille_ring_star_x_diamond_square_doughnut ; 48
.dw swap_square_grille_doughnut_diamond			   ; 64
.dw swap_square_grille_ring_star_square_diamond		   ; 80
.dw swap_x_square					   ; 96
.dw swap_grille_square_star_ring_diamond_x		   ;112
.dw swap_square_x					   ;128

swap_star_ring_doughnut_x_grille_square:
.db 36,62
.db 37,63
.db 40,66
.db 41,67

.db 18,70
.db 19,71
.db 22,74
.db 23,75

.db 16, 60
.db 17, 61
.db 20, 64
.db 21, 65

.db 1,50
.db 0

swap_square_grille:
.db 50,1

.db 60, 16
.db 61, 17
.db 64, 20
.db 65, 21

.db 0


swap_square_grille_ring_star_x_diamond_square_doughnut:
.db 50,1
.db 60, 16
.db 61, 17
.db 64, 20
.db 65, 21

.db 62,36
.db 63,37
.db 66,40
.db 67,41

.db 70,76
.db 71,77
.db 74,80
.db 75,81

.db 68,18
.db 69,19
.db 72,22
.db 73,23

.db 0

swap_square_grille_doughnut_diamond:
.db 50,1
.db 60,16
.db 61,17
.db 64,20
.db 65,21

.db 18,76
.db 19,77
.db 22,80
.db 23,81

.db 0


swap_square_grille_ring_star_square_diamond:
.db 50,1
.db 60, 16
.db 61, 17
.db 64, 20
.db 65, 21

.db 62,36
.db 63,37
.db 66,40
.db 67,41

.db 68,76
.db 69,77
.db 72,80
.db 73,81

.db 0

swap_x_square:

.db 70,68
.db 71,69
.db 74,72
.db 75,73

.db 0

swap_grille_square_star_ring_diamond_x:
.db 16, 60
.db 17, 61
.db 20, 64
.db 21, 65
.db 1,50


.db 36,62
.db 37,63
.db 40,66
.db 41,67



.db 62,76
.db 63,77
.db 66,80
.db 67,81

.db 0

swap_square_x:

.db 68,70
.db 69,71
.db 72,74
.db 73,75
.db 0

;==============================================================
; GAME PALETTES
;==============================================================

game_palettes:

;    ----BBBBGGGGRRRR

r_pal_mby:			; #00
.dw %0000111100001111
.dw %0000111100000000
.dw %0000000011111111

r_pal_bky:			; #01
.dw %0000111100000000
.dw %0000000000000000
.dw %0000000011111111

r_pal_cbw:			; #02
.dw %0000111111110000
.dw %0000111100000000
.dw %0000111111111111

r_pal_grw:			; #03
.dw %0000000011110000
.dw %0000000000001111
.dw %0000111111111111

r_pal_rkw:			; #04
.dw %0000000000001111
.dw %0000000000000000
.dw %0000111111111111

r_pal_mbc:			; #05
.dw %0000111100001111
.dw %0000111100000000
.dw %0000111111110000

r_pal_rkc:			; #06
.dw %0000000000001111
.dw %0000000000000000
.dw %0000111111110000

r_pal_gbw:			; #07
.dw %0000000011110000
.dw %0000111100000000
.dw %0000111111111111

r_pal_bkw:			; #08
.dw %0000111100000000
.dw %0000000000000000
.dw %0000111111111111

r_pal_rgw:			; #09
.dw %0000000000001111
.dw %0000000011110000
.dw %0000111111111111

r_pal_gby:			; #10
.dw %0000000011110000
.dw %0000111100000000
.dw %0000000011111111

r_pal_mkc:			; #11
.dw %0000111100001111
.dw %0000000000000000
.dw %0000111111110000

r_pal_brc:			; #12
.dw %0000111100000000
.dw %0000000000001111
.dw %0000111111110000


r_pal_bkc:			; #13
.dw %0000111100000000
.dw %0000000000000000
.dw %0000111111110000

;==============================================================
; SPRITE PALETTES
;==============================================================

sprite_palettes:

pal_spr_yr:
.dw %0000000000000000
.dw %0000000011111111
.dw %0000000000001111

pal_spr_wm:
.dw %0000000000000000
.dw %0000111111111111
.dw %0000111100001111