; MINES.ASM
; Handle drawing/moving of mines

update_mines:
	ld a,(mine_delay)
	inc a
	ld (mine_delay),a
	ld hl,mines_table
	ld a,(max_mines)
	or a
	ret z
	ld b,a
	ld b,8
-:	push bc
	ld a,(hl)

	cp 128+80
	jr nc,clear_mine_x
	cp 128-80
	jr c,clear_mine_x

	ld b,a
	inc hl			;+1
	or (hl)
	jr z,no_draw

	ld a,(hl)
	cp 16+144+8
	jr nc,clear_mine_y
	cp 16
	jr c,clear_mine_y

	ld c,(hl)
	ld d,$36
	push hl
	push bc
	call draw_sprite
	pop bc
	pop hl

	ld a,(mine_delay)
	and %00000011
	jr nz,no_draw

	inc hl			;+2
	ld a,(hl)
	add a,b
	ld b,a
	inc hl			;+3
	ld a,(hl)
	add a,c
	dec hl			;+2
	dec hl			;+1
	ld (hl),a
	dec hl			;+0
	ld (hl),b
	inc hl			;+1
no_draw:
	inc hl			;+2
	inc hl			;+3
	inc hl			;+4
	pop bc
	djnz -
	ret

clear_mine_y:
	dec hl
clear_mine_x:
	xor a 
	ld (hl),a
	inc hl			;+1
	ld (hl),a
	jr no_draw

slow_lay_mine:
	ld a,(mine_add_delay)
	inc a
	ld (mine_add_delay),a
	and %00111111
	ret nz	

lay_mine:

	ld a,b
	cp 128+80
	ret nc
	cp 128-80
	ret c

	ld a,c
	cp 16
	ret c
	cp 144
	ret nc

	push bc
	pop de
	ld hl,mines_table

	ld a,(max_mines)
	or a
	ret z
	ld b,a

-:	ld a,(hl)
	inc hl
	or (hl)
	jr z,free_mine_slot
	inc hl
	inc hl
	inc hl
	djnz -
	ret

free_mine_slot:


	dec hl
	ld a,d
	add a,4
	ld d,a
	ld (hl),a
	inc hl
	ld (hl),e

	; Now, calculate the offset

	inc hl
	ld a,(player_x)
	srl a
	srl a
	srl a
	srl a
	srl a
	srl d
	srl d
	srl d
	srl d
	srl d
	sub d
	jr nz,+
	ld a,1
+:	ld (hl),a

	inc hl
	ld a,(player_y)
	srl a
	srl a
	srl a
	srl a
	srl a
	srl e
	srl e
	srl e
	srl e
	srl e
	sub e
	jr nz,+
	ld a,1
+:
	ld (hl),a

	ld a,2
	call play_sound

	ret