; MUSIC.ASM
; Plays the music!

; Music files are lists, and the format is simple:
; BYTE Length of data
; .... Data to be written to PSG.
; If the amount of data specified is ZERO, it is assumed 
; that the music file loops back the start at that point.

load_music:
	ld (music_pos),hl
	ld (music_start),hl
	ld a,1
	ld (note_dur),a
	ret

play_music:
.ifdef DISABLE_MUSIC
	ret
.endif
	ld a,(note_dur)
	or a
	jr z,+
	dec a
	ld (note_dur),a
	ret nz
+:
	ld hl,(music_pos)

	ld a,(hl)
	cp $FF
	jr z,+
	inc hl

	or a
	jr z,++

	ld b,a
	ld c,psg_port
	otir
	
++:	

	ld a,(hl)
	inc hl
	ld (note_dur),a

	ld (music_pos),hl
	ret
	

+:	ld a,1
	ld (note_dur),a
	ld hl,(music_start)
	ld (music_pos),hl
	ret