; VARS.INC
; Defining where the variables are held in RAM

.enum ram
test_var		db
max_mines		db	; Maximum number of mines on-screen
cur_map_pos		dw	; Where are we reading from the map?							
cur_scroll_index	db	; How far the screen is scrolled							
sprite_write_a		dw	; X-location write pointer							
sprite_write_b		dw	; Y-location write pointer						
player_y		db	; Y-position of the player					
player_x		db	; X-position of the player					
game_clock		dw	; Tick-tock.					
bullets			ds 16	; All the bullets - x,y.				
looping_end		db	; Have we hit the end of the game?					
pause_offset		db	; Sine-table offset					
hit_wide_building	db	; Have we hit a "wide" building?						
tile_hit		db	; Which tile have we hit?					
tile_destroyed		db	; "Blown up" tile to sub in					
name_table_destroy	dw	; Location we've just "destroyed" (names table)						
name_ram_destroy	dw	; Location we've just "destroyed" (RAM copy of names)						
start_button_tracker	db	; Track the status of the pause button						
start_button_count	db	; How many times has START been pressed?						
title_fade_text		db	; Fading in the TEXT counter					
cur_map_end		dw	; Memory location of the end of the current map					
level_num		db	; Current level number					
shot_eyes		db	; Number of eyes shot out x_x					
real_level		dw	; Location of the "real" level data					
rand_data		dw	; Random number tracker						
music_pos		dw	; Where are we in the music track?					
music_start		dw	; Start of music track (looping)					
note_dur		db	; Duration of the current note					
decomp_level		ds 20	; Temp space to decompress level into					
sprite_limit		db	; Counter to limit max number of sprites					
enemies_shift		dw	; Pointer to function to call to move enemies					
enemies_sprite		db	; Which sprite is the current enemy?					
enemies_time		dw	; Length of enemy attack					
enemies_pattern		dw	; Pointer to current enemy pattern					
enemies_table		ds 8*8	; Array, in form dd(x,y) where dd = time					
num_lives		db	; Number of lives					
helper_pos		db	; Positions of our lives counter					
helper_ang		db	; The angle of the last helper					
cur_path		dw	; The current path (for enemies on path)					
enemy_x			ds 16	; x-coordinate of fast sine ships & storage for (dx,dy) on attackers
epilogue_txt		dw	; Location in memory of current epilogue char					
epilogue_name		dw	; Location on name table for epilogue char						
epilogue_line		db	; The line number of the epilogue					
cur_map_number		db	; The full map number (including MSB)					
i_am_dead		db	; Well, am I? :)					
level_data_table	dw	; Pointer to level data table.						
death_timer		db	; When you've died, this is decremented.					
sound_slot_num		db	; Which sound slot are we currently in?					
sound_r_pitch		dw	; Actual pitch to output					
sound_r_vol		db	; Actual volume to output					
sound_r_priority	db	; Priority of the current sound						
settings_item		db	; Selected item in settings screen					
settings_music		db	; Which music is selected as the start?					
settings_sound		db	; Which sound is selected as the start?					
settings_level		db	; Start level?					
settings_lives		db	; How many lives do we start with as standard?					
settings_inf_lives	db	; Infinite lives?
explosions_sprites	ds 32	; Array, in form (x,y)st where s = sprite, t = time						
explosions_terrain	ds 64	; Array, in form (x,y)st where s = sprite, t = time						
names_ram_copy		ds 896	; Copy of the name table, held in RAM						
sound_effects		ds 80	; Sound effects						
blown_up_ptr		dw	; Pointer to where to store blown up tiles						
blown_up_terrain	ds 512	; Huge table of "blown up" tiles on the ground
enemy_speed		db	; The speed of the enemy is huge!
stars			ds 24*4	; Scrolling stars
question_blocks		db	; Number of question blocks shot out
score			ds 10	; 10 digits, held as BCD
sprite_shad_a		ds 64	; Sprite shadow A
sprite_shad_b		ds 128	; Sprite shadow B
mines_table		ds 8*4	; Slots for the mines
mine_delay		db	; Mine delay clock
mine_add_delay		db	; Delay between adding mines
pal_from		ds 64	; Palette to fade FROM
pal_current		ds 64	; Current fade value
pal_to			ds 64	; Palette to fade TO
pal_fade_count		db	; How many colours are we fading between?
pal_fade_amount		db	; How far have we faded between them?
pal_fade_speed		db	; Speed at which we fade between the two palettes.
attack_loc		dw	; Location of pointer in attack table
attack_mode		db	; What's the attack mode?
attack_base		dw	; Base location of attack
attack_timeout		db	; Time between attacks
attack_count		db	; How many of this particular enemy do we need to add?
land_speed		db	; Bitmask for game_clock to control the landscape speed
.ende